"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
function nock(host, cb) {
    if (_.isUndefined(host))
        throw new Error('host is undefined');
    if (_.isUndefined(cb))
        throw new Error('callback is undefined');
    const nock = require('nock');
    const intercepter = nock(host);
    return {
        async run(ctx) {
            ctx.nock = ctx.nock || 0;
            await cb(intercepter);
            ctx.nock++;
        },
        finally(ctx) {
            if (!ctx.error)
                intercepter.done();
            ctx.nock--;
            if (ctx.nock === 0)
                nock.cleanAll();
        },
    };
}
exports.nock = nock;
